using FiveTuple.Coderform;

// Constraint form
public class clsConstraintsOverlay : clsDataForm
{

	private const string mstrABOUT_TITLE = "Strings";
	private clsUDStringList mobjMachineList;

	// Constructor
	public clsConstraintsOverlay() : base(mstrABOUT_TITLE)

	{

		clsDataBlockList objSelector1;
		clsDataBlockList objComputer;
		clsDataBlockList objPrinter;
		clsDataBlockList objMonitor;

		try
		{

			objSelector1 = objSelector();
			AddDataControl(objSelector1);

			objComputer = objBlockComputer();
			objComputer.Locate(objSelector1, enmPositionSet.RightUpper);
			AddDataControl(objComputer);

			objPrinter = objBlockPrinter();
			objPrinter.Locate(objComputer, enmPositionSet.TopLeft, true);
			AddDataControl(objPrinter);

			objMonitor = objBlockMonitor();
			objMonitor.Locate(objComputer, enmPositionSet.TopLeft, true);
			AddDataControl(objMonitor);


			AddConstraints();

			objComputer.SetState(enmControlState.NotVisible);
			objPrinter.SetState(enmControlState.Visible);
			objMonitor.SetState(enmControlState.NotVisible);

		}
		catch
		{

			throw;
		}

	}


	// AddConstraints
	private void AddConstraints()
	{

		clsDataControl objDataControl1;
		clsDataControl objComputer;
		clsDataControl objPrinter;
		clsDataControl objMonitor;
		clsConstraintStringList objConstraint;

		try
		{

			objDataControl1 = this.get_objDataControl("Machine");
			objComputer = this.get_objDataControl("Computer");
			objPrinter = this.get_objDataControl("Printer");
			objMonitor = this.get_objDataControl("Monitor");

			objConstraint = new clsConstraintStringList(0);
			objDataControl1.objAddDuty(objConstraint, (int) enmDutyBinding.DataChanged, enmControlState.Visible, objComputer);

			objConstraint = new clsConstraintStringList(1);
			objDataControl1.objAddDuty(objConstraint, (int) enmDutyBinding.DataChanged, enmControlState.Visible, objPrinter);

			objConstraint = new clsConstraintStringList(2);
			objDataControl1.objAddDuty(objConstraint, (int) enmDutyBinding.DataChanged, enmControlState.Visible, objMonitor);


		}
		catch
		{

			throw;
		}
	}


	// objSelector
	private clsDataBlockList objSelector()
	{

		clsDataBlockList objBlock1;


		try
		{

			objBlock1 = new clsDataBlockList("Selector");

			mobjMachineList = new clsUDStringList( "Machine", "Computer,Printer,Monitor", 1, "Machine" , enmStringList.RadioChoice);

			objBlock1.AddDataControl(mobjMachineList);

			return objBlock1;

		}
		catch
		{
			throw;
		}

	}


	// objBlockComputer
	private clsDataBlockList objBlockComputer()
	{

		clsDataBlockList objBlock1;

		try
		{

			objBlock1 = new clsDataBlockList("Computer");

			// Textbox
			objBlock1.objAddString( "CPU Speed", enmString.Textbox );

			// Textbox
			objBlock1.objAddString("CPU Vendor", "Intel",enmString.Textbox);

			// Textbox
			objBlock1.objAddInteger("RAM", 256, "RAM");


			return objBlock1;

		}
		catch
		{
			throw;
		}

	}


	// objBlockPrinter
	private clsDataBlockList objBlockPrinter()
	{

		clsDataBlockList objBlock1;
		clsConstraintNumeric objLimit;

		try
		{

			objBlock1 = new clsDataBlockList("Printer");

			// Textbox
			objBlock1.objAddString("Printer Type", "Laser", enmString.Textbox);

			// Textbox
			objBlock1.objAddInteger("Speeed in PPM", 0, "PPM");

			// Textbox
			objBlock1.objAddString("Manufacturer", "Hewlett Packard", enmString.Textbox);


			objLimit = new clsConstraintNumeric(1, 1000);
			objBlock1.get_objDataControl("PPM").objAddDuty( objLimit, enmDutyBinding.Validation, enmControlState.MessageAlert);

			return objBlock1;

		}
		catch
		{
			throw;
		}

	}


	// objBlockMonitor
	private clsDataBlockList objBlockMonitor()
	{

		clsDataBlockList objBlock1;
		clsConstraintNumeric objLimit;

		try
		{

			objBlock1 = new clsDataBlockList("Monitor");

			// Textbox
			objBlock1.objAddInteger("Size in inches", 0, "Size");

			// Textbox
			objBlock1.objAddString("Manufacturer", "Iiyama", enmString.Textbox);


			objLimit = new clsConstraintNumeric(30, 10000);
			objBlock1.get_objDataControl("Size").objAddDuty(objLimit, enmDutyBinding.Validation, enmControlState.MessageAlert);

			return objBlock1;


		}
		catch
		{
			throw;
		}

	}



}



	


