using FiveTuple.Coderform;

// Constraint form
public class clsConstraintsString : clsDataForm
{

	private const string mstrABOUT_TITLE = "Strings";
	private clsDataButton mobjApply;

	public clsConstraintsString() : base(mstrABOUT_TITLE)

	{

		try
		{

			AddTextboxes();

			AddConstraints();

		}
		catch
		{

			throw;
		}

	}


	// AddConstraints
	private void AddConstraints()
	{

		clsDataControl objDataControl1;
		clsDuty objDuty ;
		clsConstraintString objIsPostCode;

		try
		{

			objDataControl1 = this.get_objDataControl("Textbox1");

			// Example 1 - Disabled at startup
			objDataControl1.objAddDuty(enmDutyBinding.Creation, enmControlState.NotEnabled);


			// Example 2 - Highlight on Enter
			objDataControl1 = this.get_objDataControl("Textbox2");
			objDataControl1.objAddDuty(enmDutyBinding.DataEntered, enmControlState.Selected);


			// Example 3 - Marker on Leave or OK when postcode is invalid
			objDataControl1 = this.get_objDataControl("Textbox3");
			objDataControl1.ctlVisual.intRightPad = 14; // padding allows errorcontrol to be seen

			objIsPostCode = new clsConstraintString(enmCONSTRAINT_STRING.POSTCODE_UK);

			//int intState = DirectCast(enmDutyBinding.DataValidating | enmDutyBinding.Validation, int);
			objDataControl1.objAddDuty(objIsPostCode, (int) (enmDutyBinding.DataValidating | enmDutyBinding.Validation), enmControlState.MarkAlert,objDataControl1);


			// Example 4 - Message on Apply when postcode is invalid
			objDataControl1 = this.get_objDataControl("Textbox4");
			objDataControl1.ctlVisual.intRightPad = 14; // padding allows errorcontrol to be seen

			objDuty = objDataControl1.objAddDuty(objIsPostCode, enmDutyBinding.Validation, enmControlState.MessageAlert);
			objDuty.strHotTag = "Apply";

			objDuty.AddAction(objDataControl1, enmControlState.MarkAlert);

			mobjApply.objValidatedControl = objDataControl1;

		}
		catch
		{
			throw;
		}
	}

	// AddTextboxes
	private void AddTextboxes()
	{

		clsDataBlockList objBlock1;

		try
		{

			objBlock1 = new clsDataBlockList("Textboxes");


			// Textbox
			objBlock1.objAddString("Textbox1", "Disabled", enmString.Textbox);

			// Textbox
			objBlock1.objAddString("Textbox2", "Select on tab", enmString.Textbox);

			// Textbox
			objBlock1.objAddString("Textbox3", "Validation1", enmString.Textbox);

			// Textbox
			objBlock1.objAddString("Textbox4", "Validation2", enmString.Textbox);

			//Apply button
			mobjApply = new clsDataButton("Apply");

			objBlock1.AddDataControl(mobjApply);

			AddDataControl(objBlock1);

		}
		catch
		{
			throw;
		}

	}

}

	
