using FiveTuple.Coderform;
using System.Windows.Forms;

// A find dialog
public class clsFindForm : clsDataForm
{

	private clsDataButtonBlock mobjDataButtonBlock;
	private clsDataControl.evtCommandClickedEventHandler dlgClose;

	// Constructor
	public clsFindForm(string vstrCaption) : base(vstrCaption, enmFormStyle.OptionsDialog, enmButtonTypes.None, enmCompactionSet.Compact, enmPositionSet.RightUpper, vstrCaption)

	{

		string strButtons;
		clsFindBlock objBlock;

		try
		{

			objBlock = new clsFindBlock("");

			AddDataControl(objBlock);

			strButtons = "&Find Next, &Replace, &Mark All, Close";
			mobjDataButtonBlock = new clsDataButtonBlock(strButtons);

			dlgClose = new clsDataButtonBlock.evtCommandClickedEventHandler(Close);
			mobjDataButtonBlock.get_objDataButton(3).AddClickHandler(dlgClose);

			mobjDataButtonBlock.Locate(objBlock, enmPositionSet.RightUpper);
			mobjDataButtonBlock.ctlVisual.intTopPad = 0;
			AddDataControl(mobjDataButtonBlock);

			AddConstraints();

			mobjDataButtonBlock.evtCommandClicked += new clsDataForm.evtCommandClickedEventHandler(ButtonHandler);

		}
		catch
		{
			throw;
		}

	}


	//ButtonHandler
	private void ButtonHandler(object vobjSender, clsCommandClickedEventArgs vobjCommandEventArgs)
	{

		switch (vobjCommandEventArgs.strTag)
		{

			case "0":
			MessageBox.Show("Find function");
			break;
			case "1":
			MessageBox.Show("Replace function");
			break;
			case "2":
			MessageBox.Show("Mark function");
			break;
			case "3":

			break;
		}

	}


	// Add constraints to the Address template
	private void AddConstraints()
	{

		string strMessage;
		clsConstraintString objConstraintName;
		clsConstraint objChecked;

		objChecked = new clsConstraint(true);

		// Enable use combo only if checkbox is selected
		get_objUDType("UsE").objAddDuty(objChecked, (int) (enmDutyBinding.DataChanged | enmDutyBinding.Creation), enmControlState.Enabled, get_objUDType("UseWhat"));

		// Highlight find box when entered
		get_objUDType("Findbox").objAddDuty(enmDutyBinding.DataEntered | enmDutyBinding.Display, enmControlState.Selected);

		strMessage = "Please enter a string to find ";

		// Add a string constraint to the name
		objConstraintName = new clsConstraintString(4, 200, strMessage, false);

	}

	// close
	//ButtonHandler
	private void Close(object vobjSender, clsCommandClickedEventArgs vobjCommandEventArgs)
	{
		base.Close();
	}

}


// Standard find block
public class clsFindBlock : clsDataBlockList
{

#region Variables (none)

#endregion

#region Properties (none)

#endregion

#region Methods

	internal clsFindBlock(string vstrCaption) : base(vstrCaption, enmBorderStyle.None, enmCompactionSet.Regular, enmPositionSet.BottomLeft, "FindBlock")

	{

		string[] astrUseWhat = new string[1];
		string[] astrSearchRadios = new string[3];
		clsUDBoolean objCheckUse;
		clsUDString objFindBox;
		clsUDStringList objUseWhat;
		clsUDStringList objSearchRadios;
		clsDataBlock objBlockSearch;
		clsCoreCheckBlock objCheckBlock;

		try
		{

			// Find box
			objAddString("Find: ");
			objFindBox = new clsUDString("Findbox", "", "Findbox", 40, 40, enmString.Textbox);
			AddDataControl(objFindBox, enmPositionSet.RightLower);

			// Find options checkboxes
			objCheckBlock = new clsCoreCheckBlock("C&hoice", enmBorderStyle.None, null, enmCompactionSet.Compact);
			objCheckBlock.AddChoice("Match &case");
			objCheckBlock.AddChoice("Match &hidden text");
			objCheckBlock.AddChoice("&Search <nl>hidden text");
			objCheckBlock.AddChoice("Search u&p");

			// Checkbox with the combo to its right hand side
			objCheckUse = objCheckBlock.objAddBoolean("&Use", false, "Use");
			objCheckUse.ctlVisual.intTopPad = 7;
			astrUseWhat[0] = "Regular Expressions";
			objUseWhat = new clsUDStringList("UseWhat", ref astrUseWhat, 0, "UseWhat", enmStringList.Combobox);
			objCheckBlock.AddDataControl(objUseWhat, enmPositionSet.RightMiddle);

			AddDataControl(objCheckBlock);

			// Add search radios
			astrSearchRadios[0] = "Current &document";
			astrSearchRadios[1] = "All &open document";
			astrSearchRadios[2] = "Only &this procedure";

			objSearchRadios = new clsUDStringList("SearchRadios", ref astrSearchRadios, 0, "SearchRadios", enmStringList.RadioChoice);
			objBlockSearch = new clsDataBlock("Search", enmBorderStyle.Rectangular);
			objBlockSearch.AddDataControl(objSearchRadios);
			objBlockSearch.ctlVisualContainer.intLeftMargin = 9;
			objBlockSearch.ctlVisualContainer.intBottomMargin = 26;
			AddDataControl(objBlockSearch, enmPositionSet.RightUpper);

		}
		catch
		{
			throw;
		}

	}


#endregion

}

   
