using System.Windows.Forms;
using FiveTuple.Coderform;

// clsCustomLists is demo of UDStringList types
public class clsCustomListForm : clsDataForm
{

	private clsUDStringList mobjUDChoice;
	private clsDataButton mobjButton1;
	private clsUDInteger mobjSelection;

	public clsCustomListForm(string vstrCaption) : base(vstrCaption, enmFormStyle.OptionsDialog, enmButtonTypes.OK, enmCompactionSet.Regular, enmPositionSet.BottomRight, "")

	{

		try
		{

			clsDataBlockList objGeneralBlock = null;

			objGeneralBlock = objCustomBlock();

			AddDataControl(objGeneralBlock);

			AddDataControl(objButtonBlock(), enmPositionSet.RightUpper);

			mobjSelection = new clsUDInteger("SelectedIndexes");

			AddDataControl(mobjSelection, enmPositionSet.BottomLeft);

			mobjButton1.evtCommandClicked += new clsDataButton.evtCommandClickedEventHandler(ShowSelection);

			mobjSelection.evtDataChanged += new clsDataForm.evtDataChangedEventHandler(ChangeSelection);

		}
		catch
		{
			throw;
		}

	}


	// objCustomBlock
	private clsDataBlockList objCustomBlock()
	{


		string[] astrPickList = {"Red", "Green", "Orange"}; // , "Pink with black spots", "Yellow", "Green", "Purple", "White"}
		clsDataBlockList objBlock = null;

		objBlock = new clsDataBlockList("Block");

		mobjUDChoice = new clsUDStringList("Chooser", ref astrPickList, 0, "Chooser", enmStringList.CheckChoice);

		// Add the combo box
		objBlock.AddDataControl(mobjUDChoice);

		return objBlock;

	}


	// Add buttons 
	private clsDataBlockList objButtonBlock()
	{
		clsDataBlockList objButtonBlock_temp;

		objButtonBlock_temp = new clsDataBlockList("", enmBorderStyle.None, enmCompactionSet.None, enmPositionSet.DefaultPosition,"");

		mobjButton1 = new clsDataButton("&Show selection");
		mobjButton1.sglDataWidth = -1;
		mobjButton1.sglDataHeight = -1;

		objButtonBlock_temp.AddDataControl(mobjButton1, enmPositionSet.DefaultPosition, enmCompactionSet.None);

		return objButtonBlock_temp;
	}


	// mobjButton1 handler
	private void ShowSelection(object vobjSender, clsCommandClickedEventArgs vobjCommandClosedEventArgs)
	{

		string strSelection;

		strSelection = null;

		if (mobjUDChoice.astrValue != null) 
		{

			foreach (string strString in mobjUDChoice.astrValue)
			{

				strSelection += strString + ",";
			}
			strSelection = strSelection.Substring(0, strSelection.Length - 1);

		}
		else 
		{
			strSelection = "Empty";
		}

		MessageBox.Show("Selection is " + strSelection);
	}



	// mobjSelection handler
	private void ChangeSelection(object vobjSender, clsDataChangedEventArgs vobjEventArgs)
	{

		int intI, intTop, intIndex,intBCDValue, intBit;
		int[] aintTemp, aintSelection ;
		string[] astrGamut;

		intIndex = 0;
		astrGamut = ((string[])(mobjUDChoice.objGamut));

		aintSelection = new int[astrGamut.Length + 1];

		intBCDValue = mobjSelection.intValue;

		intTop = astrGamut.Length - 1;
		for (intI = 0; intI <= intTop; intI++)
		{

			intBit = (int)((System.Math.Pow(2, intI)));
			if ((intBCDValue & intBit) == intBit)
			{

				aintSelection[intIndex] = intI;
				intIndex += 1;
			}

		}

		aintTemp = new int[intIndex];

		if (aintSelection != null)
			System.Array.Copy(aintSelection, aintTemp, System.Math.Min(aintSelection.Length, aintTemp.Length));
		
		aintSelection = aintTemp;

		mobjUDChoice.aintSelection = aintSelection;

	}


}






