using System.Windows.Forms;
using FiveTuple.Coderform;

// A find dialog
public class clsPrintForm : clsDataForm
{

	private clsDataButtonBlock mobjDataButtonBlock;

// clsPrintForm
	public clsPrintForm(string vstrCaption) : base(vstrCaption, enmFormStyle.OptionsDialog, enmButtonTypes.None, enmCompactionSet.Compact, enmPositionSet.RightUpper, vstrCaption)

	{

		string strButtons;
		clsPrinterBlock objBlock;
		clsDataBlockList objPrintRangePaneLocal;
		clsDataBlockList objCopiesPaneLocal;

		try
		{

			// Printer choice pane
			objBlock = new clsPrinterBlock("&Printer", enmBorderStyle.Rectangular);
			objBlock.ctlVisual.intBottomPad = 0;
			AddDataControl(objBlock);

			// Range pane
			objPrintRangePaneLocal = objPrintRangePane();
			objPrintRangePaneLocal.ctlVisual.intBottomPad = 8;
			objPrintRangePaneLocal.ctlVisual.intTopPad = 0;
			AddDataControl(objPrintRangePaneLocal);

			// Copies pane
			objCopiesPaneLocal = objCopiesPane();
			objCopiesPaneLocal.ctlVisual.intBottomPad = 8;
			objCopiesPaneLocal.ctlVisual.intLeftPad = 8;
			objCopiesPaneLocal.ctlVisual.intTopPad = 0;
			objCopiesPaneLocal.ctlVisualContainer.intBottomMargin = 13;
			objCopiesPaneLocal.Locate(objPrintRangePaneLocal, enmPositionSet.RightUpper,false);
			AddDataControl(objCopiesPaneLocal);

			// Form buttons
			strButtons = "&Print, Close";
			mobjDataButtonBlock = new clsDataButtonBlock(strButtons,enmDirectionSet.TopDown,enmCompactionSet.Regular,"Button","Button",enmBorderStyle.None,",");
			mobjDataButtonBlock.Locate(objBlock, enmPositionSet.RightUpper,false);

			AddDataControl(mobjDataButtonBlock);

			mobjDataButtonBlock.evtCommandClicked += new clsDataButtonBlock.evtCommandClickedEventHandler(ButtonHandler);

		}
		catch 
		{
			throw;
		}

	}


	//ButtonHandler
	private void ButtonHandler(object vobjSender, clsCommandClickedEventArgs vobjCommandEventArgs)
	{

		switch (vobjCommandEventArgs.strTag)
		{

			case "Button0":
			
				MessageBox.Show("Print function");
				break;

			case "Button1":
			
				this.Close();
				break;
		}

	}


	// Add buttons adds OK, Cancel buttons for a form
	private clsDataBlockList objPrintRangePane()
	{
		clsDataBlockList objPrintRangePane_temp;

		string[] astrRangeRadios = new string[3];
		clsUDStringList objRangeRadios;

		objPrintRangePane_temp = new clsDataBlockList("Print R&ange", enmBorderStyle.Rectangular, enmCompactionSet.Regular,enmPositionSet.LeftUpper,"PrintTange");

		// Add Range radios
		astrRangeRadios[0] = "All";
		astrRangeRadios[1] = "Pages 1 to 1";
		astrRangeRadios[2] = "Selection";

		objRangeRadios = new clsUDStringList("RangeRadios", ref astrRangeRadios, 0, "", enmStringList.RadioChoice);
        objRangeRadios.ctlVisual.intBottomPad = 9;

		objPrintRangePane_temp.AddDataControl(objRangeRadios);

		return objPrintRangePane_temp;
	}

// Add buttons adds OK, Cancel buttons for a form
	private clsDataBlockList objCopiesPane()
	{
		clsDataBlockList objCopiesPane_temp;

		string[] astrCopies = {"1", "2", "3"};
		clsUDStringList objCopies;
		clsUDBoolean objCollate;
		clsUDBitmap objIcon;

		objCopiesPane_temp = new clsDataBlockList("&Copies", enmBorderStyle.Rectangular, enmCompactionSet.Regular, enmPositionSet.LeftUpper,"Copies");

		objCopiesPane_temp.objAddString("Number of copies");
		objCopies = new clsUDStringList("UseWhat", ref astrCopies, 0, "UseWhat", enmStringList.Combobox);

		objCopiesPane_temp.AddDataControl(objCopies, enmPositionSet.RightUpper, enmCompactionSet.None);

		objIcon = new clsUDBitmap(enmLib.doc_dupl, "Icon1", "Icon1", enmImage.Bitmap);
		objIcon.ctlVisual.intRightPad = 20;
		objCopiesPane_temp.AddDataControl(objIcon);

		objCollate = new clsUDBoolean("C&ollate", true, "Collate", enmBoolean.CheckBox);
		objCollate.Locate(objIcon, enmPositionSet.RightLower, false);
		objCopiesPane_temp.AddDataControl(objCollate);

		// Tidy alignment manually
		objCopiesPane_temp.ctlVisual.intBottomPad += 10;

		return objCopiesPane_temp;
	}

}


// Standard find block
public class clsPrinterBlock : clsDataBlockList
{


#region Variables

#endregion

#region Properties (none)

#endregion

#region Methods


	internal clsPrinterBlock(string vstrCaption, enmBorderStyle venmBorder) : base(vstrCaption, venmBorder, enmCompactionSet.Regular, enmPositionSet.LeftUpper, vstrCaption)

	{

		string[] astrPrinters = new string[1];
		string[] astrSearchRadios = new string[3];
		clsUDStringList objPrinter;
		clsDataButton objButton1;

		try
		{

			// Printer dropdown
			objAddString("Printer: ");
			astrPrinters[0] = "\\\\ARGON\\HP LaserJet 3300";
			objPrinter = new clsUDStringList("UseWhat", ref astrPrinters, 0, "UseWhat", enmStringList.Combobox);
			AddDataControl(objPrinter, enmPositionSet.RightUpper, enmCompactionSet.Regular);

			// Properties button
			objButton1 = new clsDataButton("Properties", false, "False", 10, 1, null, enmButton.WindowsButton);
			objButton1.ctlVisual.intLeftPad = 10;
			AddDataControl(objButton1, enmPositionSet.RightUpper, enmCompactionSet.Regular);

			objAddString("Status");
			objAddString("Type");
			objAddString("Where");
			objAddString("Comment");


			objButton1.evtCommandClicked += new clsDataButton.evtCommandClickedEventHandler(PrinterProperties);

		}
		catch
		{
			throw;
		}

	}


	// Stub for Properties button
	private void PrinterProperties(object vobjSender, clsCommandClickedEventArgs vobjCommandEventArgs)
	{

		MessageBox.Show("Demo only");
	}

#endregion


}

    