using System.Data;
using FiveTuple.Coderform;

// A find dialog
public class clsViewForm : clsDataForm
{

	private bool mblnSwap;
	private DataTable mtblSample;
	private DataTable mtblSample1;
	private DataTable mtblSample2;

	private clsUDViewSet mobjViewSet;
	private clsDataButton mobjButton1;
	private clsCoreStringBlock mobjFieldBlock;

	// Constructor

	public clsViewForm(string vstrCaption) : base(vstrCaption, enmFormStyle.OptionsDialog, enmButtonTypes.None, enmCompactionSet.Compact, enmPositionSet.DefaultPosition, "")

	{

		string strFormat = "";
		clsDataBlockList objButtonBlockLocal;

		try
		{

			mtblSample1 = mdlGeneral.tblGetSample(1);
			mtblSample2 = mdlGeneral.tblGetSample(2);
			mblnSwap = false;
			mtblSample = mtblSample1;

			mobjViewSet = new clsUDViewSet("Sample", mtblSample, "SampleList", strFormat, enmViewSet.ListView);
			mobjViewSet.sglDataWidth = 20;

			AddDataControl(mobjViewSet);

			objButtonBlockLocal = objButtonBlock();

			mobjFieldBlock = objFieldBlock();

			AddDataControl(mobjFieldBlock, enmPositionSet.RightUpper);

			AddDataControl(objButtonBlockLocal, enmPositionSet.BottomLeft);

			mobjButton1.evtCommandClicked += new clsDataControl.evtCommandClickedEventHandler(SwapDataset);
			mobjViewSet.evtDataChanged += new clsDataForm.evtDataChangedEventHandler(UpdateFields);

		}
		catch
		{
			throw;
		}

	}


	// Add buttons adds OK, Cancel buttons for a form
	private clsDataBlockList objButtonBlock()
	{
		clsDataBlockList objButtonBlock_temp;

		objButtonBlock_temp = new clsDataBlockList( "ButtonBlock", enmBorderStyle.None, enmCompactionSet.None, enmPositionSet.DefaultPosition, "ButtonBlock");

		mobjButton1 = new clsDataButton("Swap Dataset");
		mobjButton1.sglDataWidth = -1;
		objButtonBlock_temp.AddDataControl(mobjButton1);
		this.AcceptButton = mobjButton1;

		return objButtonBlock_temp;
	}


	// Adds fields
	private clsCoreStringBlock objFieldBlock()
	{

		string strFields;
		clsCoreStringBlock objBlock;

		strFields = "";
		foreach (DataColumn dclColumn in mtblSample1.Columns)
		{

			strFields += dclColumn.ColumnName + ",";
		}

		strFields = strFields.Substring(0, strFields.Length - 1);

		objBlock = new clsCoreStringBlock("Detail", strFields, 20);

		return objBlock;
	}


	//SwapDataset
	private void SwapDataset(object vobjSender, clsCommandClickedEventArgs vobjCommandClosedEventArgs)
	{

		if (mobjViewSet.aintSelection != null) 
		{

			if (mblnSwap)
			{

				mtblSample = mtblSample2;
			}
			else
			{
				mtblSample = mtblSample1;
			}

			mobjViewSet.objGamut = mtblSample;
			mblnSwap = ! mblnSwap;

			UpdateFields(null, null);

		}
	}


	// mobjViewSet Selection Changed handler
	private void UpdateFields(object vobjSender, clsDataChangedEventArgs vobjEventArgs)
	{

		string strCol;
		string strField;

		foreach (DataColumn dclColumn in mtblSample.Columns)
		{

			strCol = dclColumn.ColumnName;
			strField = mtblSample.Rows[mobjViewSet.intSelection][strCol].ToString();
			mobjFieldBlock.get_objDataControl(strCol).strValue = strField;

		}

	}


}

