using System;
using System.Drawing;
using System.Windows.Forms;
using FiveTuple.Coderform;

// clsMainForm demonstrates DataForm
public class clsMainForm : clsDataForm
{

	internal clsMainForm() : base("DataForm Demo", enmFormStyle.FixedForm, enmButtonTypes.OKReturnCancelEscape,enmCompactionSet.Regular,enmPositionSet.BottomRight,"DataFormDemo")

	{

		clsUDString objString;
		clsDataMenu objFormsMenu;
		clsDataMenu objSubMenu1;
		clsDataMenu objSubMenu2;

		try
		{

			// Header menu File
			objAddMenu("&File", "E&xit",enmMenuSitingSet.enmMenuDefaultSiting,",");

			// Header menu Controls
		    objAddMenu("Controls", "Boolean,Numerics,Dates,-,String,String Lists,-,Image,ViewSets,Buttons");

			// Header menu Constraints
			objAddMenu("Constraints", "String - simple, Numeric, Date, Stringlist, Overlay",enmMenuSitingSet.enmMenuDefaultSiting,",");
 
			// Header menu Forms
			objFormsMenu = objAddDataMenu("Forms","Forms",enmMenuSitingSet.enmMenuDefaultSiting);

			// Header menu Help
			objAddMenu("Help", "Test,About..",enmMenuSitingSet.enmMenuDefaultSiting,",");

			// Submenu Basic Forms 
			objSubMenu1 = objFormsMenu.objAddMenu("Basic Forms", "Simple Form,Tabbed Form,Menus",enmMenuSitingSet.enmMenuDefaultSiting,",");


            objSubMenu1.get_objGetDataMenu(0).enmIcon = enmMenuIcon.doc;
            objSubMenu1.get_objGetDataMenu(1).enmIcon = enmMenuIcon.doc_tabbed_new;
            objSubMenu1.get_objGetDataMenu(2).enmIcon = enmMenuIcon.select1;

			objSubMenu1.enmIcon = enmMenuIcon.arrow_blue_right;

			// Submenu Custom Forms 
			objSubMenu2 = objFormsMenu.objAddMenu("Custom Forms", "Find, Print",enmMenuSitingSet.enmMenuDefaultSiting,",");
			objSubMenu2.get_objGetDataMenu(0).enmIcon = enmMenuIcon.find;
			objSubMenu2.get_objGetDataMenu(1).enmIcon = enmMenuIcon.print;

			// Submenu Various
			objFormsMenu.objAddMenu("Various", "Button Blocks",enmMenuSitingSet.enmMenuDefaultSiting,",");

			// Submenu Tables and Lists
			objFormsMenu.objAddMenu("Tables and Lists", "View Form, Lists",enmMenuSitingSet.enmMenuDefaultSiting,",");

			// Submenu Plugins
			objFormsMenu.objAddMenu("Plugins", "Separator",enmMenuSitingSet.enmMenuDefaultSiting,",");

			// Submenu Standard
			

			objString = objAddString(" ");
			objString.ctlVisual.intTopPad = 60;
			objString.ctlVisual.intBottomPad = 200;
			objString.ctlVisual.intRightPad = 300;

			base.evtMenuClicked += new clsDataControl.evtMenuClickedEventHandler(MenuClickEventHandler);

		}
		catch
		{
			throw;
		}

	}


	// MenuClickEventHandler
	internal void MenuClickEventHandler(object vobjSender, clsMenuClickedEventArgs vobjEventArgs)
	{

		string strTag;

		try
		{

			strTag = vobjEventArgs.strTag;

			// File menu options
			if (strTag == "Exit")
			{
				this.Close();
			}

			// Control menu options
			if (strTag == "Boolean")
			{
				RunControlForm(new clsBooleanForm());
			}
			if (strTag == "Numerics")
			{
				RunControlForm(new clsNumericForm());
			}
			if (strTag == "Dates")
			{
				RunControlForm(new clsDateForm());
			}
			if (strTag == "String")
			{
				RunControlForm(new clsStringForm());
			}
			if (strTag == "Image")
			{
				RunControlForm(new clsImageForm());
			}
			if (strTag == "String Lists")
			{
				RunControlForm(new clsStringListForm());
			}
			if (strTag == "ViewSets")
			{
				RunControlForm(new clsViewSetForm());
			}
			if (strTag == "Buttons")
			{
				RunControlForm(new clsButtonForm());
			}


			// Constraint menu options
			if (strTag == "String - simple")
			{
				RunControlForm(new clsConstraintsString());
			}
			if (strTag == "Numeric")
			{
				RunControlForm(new clsConstraintsNumeric());
			}
			if (strTag == "Date")
			{
				RunControlForm(new clsConstraintsDate());
			}
			if (strTag == "Stringlist")
			{
				RunControlForm(new clsConstraintsStringList());
			}
			if (strTag == "Overlay")
			{
				RunControlForm(new clsConstraintsOverlay());
			}


			// Form menu options
			if (strTag == "Simple Form")
			{
				mdlFormDemos.RunSimpleForm();
			}
			if (strTag == "Tabbed Form")
			{
				mdlFormDemos.RunCustomTabbedForm();
			}
			if (strTag == "Menus")
			{
				mdlFormDemos.RunSimpleFormMenu();
			}
			if (strTag == "Find")
			{
				mdlFormDemos.RunCustomFindForm();
			}
			if (strTag == "Print")
			{
				mdlFormDemos.RunCustomPrintForm();
			}
			if (strTag == "Button Blocks")
			{
				mdlFormDemos.RunSimpleButtonBlock();
			}
			if (strTag == "View Form")
			{
				mdlFormDemos.RunCustomViewForm();
			}
			if (strTag == "Lists")
			{
				mdlFormDemos.RunCustomLists();
			}
			if (strTag == "Separator")
			{
				mdlFormDemos.RunSimpleCustomControls();
			}

			// Help menu options
			if (strTag == "Test")
			{
				RunTest();
			}

			if (strTag == "About..")
			{
				ShowAbout();
			}


		}
		catch (Exception objException)
		{

			mdlMainStart.gobjErrorHandler.ErrorHandler(objException);

		}

	}


	// RunViewsetControls
	internal void RunControlForm(clsDataForm vobjForm)
	{


		try
		{

			vobjForm.Expose(true);

			vobjForm.Dispose();

		}
		catch (Exception objException)
		{

			 mdlMainStart.gobjErrorHandler.ErrorHandler(objException);

		}

	}


	// ShowAbout
	private void ShowAbout()
	{


		clsAboutForm objAboutForm;

		try
		{

			objAboutForm = new clsDataFormTestAbout();

			objAboutForm.Expose(true);

			objAboutForm.Dispose();

		}
		catch (Exception objException)
		{

			mdlMainStart.gobjErrorHandler.ErrorHandler(objException);

		}

	}

	
	// RunTest
	private void RunTest()
	{

		int intI = 0;
		System.DateTime dtmT1 = new System.DateTime();
		System.DateTime dtmT2 = new System.DateTime();
		clsPrintForm objPrintForm;

		try
		{

			dtmT1 = System.DateTime.Now;

			for (intI = 1; intI <= 100; intI++)
			{

				objPrintForm = new clsPrintForm("Print");

				objPrintForm.Expose(false);

				objPrintForm.Close();

				objPrintForm.Dispose();

			}

			dtmT2 = System.DateTime.Now;

			MessageBox.Show("The test took " + dtmT2.Subtract(dtmT1).ToString() + " seconds");

		}
		catch (Exception objException)
		{

			mdlMainStart.gobjErrorHandler.ErrorHandler(objException);

		}

	}

}






