

' Constraint form
Public Class clsConstraintsDate

    Inherits clsDataForm

    Private Const mstrABOUT_TITLE As String = "Dates"
    Private mobjApply As clsDataButton

    Public Sub New()

        MyBase.New(mstrABOUT_TITLE, enmFormStyle.FixedForm, enmButtonTypes.OKReturnCancelEscape, _
                   enmCompactionSet.Regular, enmPositionSet.BottomLeft)


        Try

            AddDates()

            AddConstraints()

        Catch objException As Exception

            Throw
        End Try

    End Sub

    ' AddConstraints
    Private Sub AddConstraints()

        Dim objDataControl1, objDataControl2, objDataControl3 As clsDataControl
        Dim objDuty As clsDuty
        Dim objAction As clsDutyAction
        Dim objConstraint As clsConstraintDate

        Try

            objDataControl1 = Me.objDataControl("Date1")

            objDataControl2 = Me.objDataControl("Date2")

            ' Example 7
            objConstraint = New clsConstraintDate(enmCONSTRAINT_DATE.WEEKDAY)
            objDataControl1.objAddDuty(objConstraint, _
                                       enmDutyBinding.DataChanged Or enmDutyBinding.Validation, _
                                       enmControlState.MessageAlert)

            ' Example 8
            objConstraint = New clsConstraintDate(Now.AddDays(1), Now.AddDays(7))
            objDataControl2.objAddDuty(objConstraint, _
                                       enmDutyBinding.DataChanged Or enmDutyBinding.Validation, _
                                       enmControlState.MessageAlert)

        Catch objException As Exception

            Throw
        End Try

    End Sub

    ' AddDates
    Private Sub AddDates()

        Dim objDate1, objDate2 As clsUDDate

        Dim objBlock1 As clsDataBlockList

        Try

            objBlock1 = New clsDataBlockList("Dates", enmBorderStyle.Rectangular)

            With objBlock1

                objDate1 = New clsUDDate("Date1", Now)

                objDate2 = New clsUDDate("Date2", Now)

                .AddDataControl(objDate1)

                .AddDataControl(objDate2)

            End With

            AddDataControl(objBlock1)

        Catch objException As Exception

            Throw
        End Try

    End Sub


End Class


