

' Constraint form
Public Class clsConstraintsOverlay

    Inherits clsDataForm

    Private Const mstrABOUT_TITLE As String = "Strings"
    Private WithEvents mobjMachineList As clsUDStringList

    ' Constructor
    Public Sub New()

        MyBase.New(mstrABOUT_TITLE, enmFormStyle.FixedForm, enmButtonTypes.OKReturnCancelEscape, _
                   enmCompactionSet.Regular, enmPositionSet.BottomLeft)


        Dim objSelector1 As clsDataBlockList
        Dim objComputer, objPrinter, objMonitor As clsDataBlockList

        Try

            objSelector1 = objSelector()
            AddDataControl(objSelector1)

            objComputer = objBlockComputer()
            objComputer.Locate(objSelector1, enmPositionSet.RightUpper)
            AddDataControl(objComputer)

            objPrinter = objBlockPrinter()
            objPrinter.Locate(objComputer, enmPositionSet.TopLeft, True)
            AddDataControl(objPrinter)

            objMonitor = objBlockMonitor()
            objMonitor.Locate(objComputer, enmPositionSet.TopLeft, True)
            AddDataControl(objMonitor)

            AddConstraints()

            objComputer.SetState(enmControlState.NotVisible)
            objPrinter.SetState(enmControlState.Visible)
            objMonitor.SetState(enmControlState.NotVisible)

        Catch objException As Exception

            Throw
        End Try

    End Sub

    ' AddConstraints
    Private Sub AddConstraints()

        Dim objDataControl1 As clsDataControl
        Dim objComputer, objPrinter, objMonitor As clsDataControl
        Dim objAction As clsDutyAction
        Dim objConstraint As clsConstraintStringList

        Try

            objDataControl1 = Me.objDataControl("Machine")
            objComputer = Me.objDataControl("Computer")
            objPrinter = Me.objDataControl("Printer")
            objMonitor = Me.objDataControl("Monitor")

            objConstraint = New clsConstraintStringList(0, 0)
            objDataControl1.objAddDuty(objConstraint, enmDutyBinding.DataChanged, _
                            enmControlState.Visible, objComputer)

            objConstraint = New clsConstraintStringList(1, 1)
            objDataControl1.objAddDuty(objConstraint, enmDutyBinding.DataChanged, _
                            enmControlState.Visible, objPrinter)

            objConstraint = New clsConstraintStringList(2, 2)
            objDataControl1.objAddDuty(objConstraint, enmDutyBinding.DataChanged, _
                            enmControlState.Visible, objMonitor)


        Catch objException As Exception

            Throw
        End Try

    End Sub

    ' objSelector
    Private Function objSelector() As clsDataBlockList

        Dim objBlock1 As clsDataBlockList


        Try

            objBlock1 = New clsDataBlockList("Selector", enmBorderStyle.Rectangular)

            mobjMachineList = New clsUDStringList("Machine", "Computer,Printer,Monitor", _
                                                  1, , enmStringList.RadioChoice)

            objBlock1.AddDataControl(mobjMachineList)

            Return objBlock1


        Catch objException As Exception

            Throw
        End Try

    End Function

    ' objBlockComputer
    Private Function objBlockComputer() As clsDataBlockList

        Dim objString As clsUDString
        Dim objBlock1 As clsDataBlockList

        Try

            objBlock1 = New clsDataBlockList("Computer", enmBorderStyle.Rectangular)

            With objBlock1

                ' Textbox
                .objAddString("CPU Speed", "")

                ' Textbox
                .objAddString("CPU Vendor", "Intel")

                ' Textbox
                .objAddInteger("RAM", Nothing, "RAM")

            End With

            Return objBlock1


        Catch objException As Exception

            Throw
        End Try

    End Function

    ' objBlockPrinter
    Private Function objBlockPrinter() As clsDataBlockList

        Dim objString As clsUDString
        Dim objBlock1 As clsDataBlockList
        Dim objLimit As clsConstraintNumeric

        Try

            objBlock1 = New clsDataBlockList("Printer", enmBorderStyle.Rectangular)

            With objBlock1

                ' Textbox
                .objAddString("Printer Type", "Laser")

                ' Textbox
                .objAddInteger("Speeed in PPM", Nothing, "PPM")

                ' Textbox
                .objAddString("Manufacturer", "Hewlett Packard")

            End With

            objLimit = New clsConstraintNumeric(1, 1000)
            objBlock1.objDataControl("PPM").objAddDuty(objLimit, enmDutyBinding.Validation)

            Return objBlock1


        Catch objException As Exception

            Throw
        End Try

    End Function

    ' objBlockMonitor
    Private Function objBlockMonitor() As clsDataBlockList


        Dim objString As clsUDString
        Dim objBlock1 As clsDataBlockList
        Dim objLimit As clsConstraintNumeric

        Try

            objBlock1 = New clsDataBlockList("Monitor", enmBorderStyle.Rectangular)

            With objBlock1

                ' Textbox
                .objAddInteger("Size in inches", Nothing, "Size")

                ' Textbox
                .objAddString("Manufacturer", "Iiyama")

            End With

            objLimit = New clsConstraintNumeric(30, 10000)
            objBlock1.objDataControl("Size").objAddDuty(objLimit, enmDutyBinding.Validation)

            Return objBlock1


        Catch objException As Exception

            Throw
        End Try

    End Function


#If False Then

    ' OnChange
    Private Sub OnChange(ByVal vobjSender As Object, _
                         ByVal vobjEventArgs As clsDataChangedEventArgs) 'Handles mobjMachineList.evtDataChanged


        Dim objComputer, objPrinter, objMonitor As clsDataControl

        objComputer = Me.objDataControl("Computer")
        objPrinter = Me.objDataControl("Printer")
        objMonitor = Me.objDataControl("Monitor")

        Select Case mobjMachineList.intSelection

            Case 0

                objComputer.SetState(enmControlState.Visible)
                objPrinter.SetState(enmControlState.NotVisible)
                objMonitor.SetState(enmControlState.NotVisible)

            Case 1

                objComputer.SetState(enmControlState.NotVisible)
                objPrinter.SetState(enmControlState.Visible)
                objMonitor.SetState(enmControlState.NotVisible)

            Case 2

                objComputer.SetState(enmControlState.NotVisible)
                objPrinter.SetState(enmControlState.NotVisible)
                objMonitor.SetState(enmControlState.Visible)

        End Select

    End Sub

#End If

End Class


