

' Constraint form
Public Class clsConstraintsString

    Inherits clsDataForm

    Private Const mstrABOUT_TITLE As String = "Strings"
    Private mobjApply As clsDataButton

    'Constructor
    Public Sub New()

        MyBase.New(mstrABOUT_TITLE, enmFormStyle.FixedForm, enmButtonTypes.OKReturnCancelEscape, _
                   enmCompactionSet.Regular, enmPositionSet.BottomLeft)

        Try

            AddTextboxes()

            AddConstraints()

        Catch objException As Exception

            Throw
        End Try

    End Sub

    ' AddConstraints
    Private Sub AddConstraints()

        Dim objDataControl1 As clsDataControl
        Dim objDuty As clsDuty
        Dim objIsPostCode As clsConstraintString

        Try

            objDataControl1 = Me.objDataControl("Textbox1")

            ' Example 1 - Disabled at startup
            objDataControl1.objAddDuty(enmDutyBinding.Creation, enmControlState.NotEnabled)


            ' Example 2 - Highlight on Enter
            objDataControl1 = Me.objDataControl("Textbox2")
            objDataControl1.objAddDuty(enmDutyBinding.DataEntered, enmControlState.Selected)


            ' Example 3 - Marker on Leave or OK when postcode is invalid
            objDataControl1 = Me.objDataControl("Textbox3")
            objDataControl1.ctlVisual.intRightPad = 14 ' padding allows errorcontrol to be seen

            objIsPostCode = New clsConstraintString(enmCONSTRAINT_STRING.TELEPHONE_INTL)

            objDataControl1.objAddDuty(objIsPostCode, enmDutyBinding.DataValidating Or enmDutyBinding.Validation, _
                                       enmControlState.MarkAlert)


            ' Example 4 - Message on Apply when postcode is invalid
            objDataControl1 = Me.objDataControl("Textbox4")
            objDataControl1.ctlVisual.intRightPad = 14 ' padding allows errorcontrol to be seen

            objDuty = objDataControl1.objAddDuty(objIsPostCode, enmDutyBinding.Validation, _
                                                 enmControlState.MessageAlert)
            objDuty.strHotTag = "Apply"

            objDuty.AddAction(objDataControl1, enmControlState.MarkAlert)

            mobjApply.objValidatedControl = objDataControl1

        Catch objException As Exception

            Throw
        End Try

    End Sub

    ' AddTextboxes
    Private Sub AddTextboxes()

        Dim objTextbox As clsUDString
        Dim objBlock1 As clsDataBlockList

        Try

            objBlock1 = New clsDataBlockList("Textboxes", enmBorderStyle.Rectangular)

            With objBlock1

                ' Textbox
                .objAddString("Textbox1", "Disabled")

                ' Textbox
                .objAddString("Textbox2", "Select on tab")

                ' Textbox
                .objAddString("Textbox3", "Validation1")

                ' Textbox
                .objAddString("Textbox4", "Validation2")

                'Apply button
                mobjApply = New clsDataButton("Apply")

                .AddDataControl(mobjApply)

            End With

            AddDataControl(objBlock1)


        Catch objException As Exception

            Throw
        End Try

    End Sub


End Class


