

' Constraint form
Public Class clsConstraintsStringList

    Inherits clsDataForm

    Private Const mstrABOUT_TITLE As String = "StringList"
    Private mobjApply As clsDataButton

    'Constructor
    Public Sub New()

        MyBase.New(mstrABOUT_TITLE, enmFormStyle.FixedForm, enmButtonTypes.OKReturnCancelEscape, _
                   enmCompactionSet.Regular, enmPositionSet.BottomLeft)

        Try

            AddControls()

            AddConstraints()

        Catch objException As Exception

            Throw
        End Try

    End Sub

    ' AddConstraints
    Private Sub AddConstraints()

        Dim objDataControl1 As clsDataControl
        Dim objLabel1, objLabel2, objLabel3 As clsDataControl
        Dim objDuty As clsDuty
        Dim objAction As clsDutyAction
        Dim objConstraint As clsConstraintStringList

        Try

            
            objDataControl1 = Me.objDataControl("StringList1")

            objLabel1 = Me.objDataControl("Item1")
            objLabel2 = Me.objDataControl("Item2")
            objLabel3 = Me.objDataControl("Item3")

            ' Physically overlay the controls
            objLabel2.Locate(objLabel1, enmPositionSet.TopLeft, True)
            objLabel3.Locate(objLabel1, enmPositionSet.TopLeft, True)

            objConstraint = New clsConstraintStringList(0)
            objDataControl1.objAddDuty(objConstraint, _
                                       enmDutyBinding.Display Or enmDutyBinding.DataChanged, _
                                        enmControlState.Visible, objLabel1)

            objConstraint = New clsConstraintStringList(1)
            objDataControl1.objAddDuty(objConstraint, _
                                       enmDutyBinding.Display Or enmDutyBinding.DataChanged, _
                                       enmControlState.Visible, objLabel2)


            objConstraint = New clsConstraintStringList(2, 3)
            objDataControl1.objAddDuty(objConstraint, _
                                       enmDutyBinding.Display Or enmDutyBinding.DataChanged, _
                                       enmControlState.Visible, objLabel3)


        Catch objException As Exception

            Throw
        End Try

    End Sub

    ' AddControls
    Private Sub AddControls()

        Dim intSize, intI As Integer
        Dim astrList() As String
        Dim objStringList As clsUDStringList
        Dim objBlock1 As clsDataBlockList

        Try

            intSize = 4

            objBlock1 = New clsDataBlockList("String Lists", enmBorderStyle.Rectangular, enmCompactionSet.Regular)

            With objBlock1

                ReDim astrList(intSize - 1)

                For intI = 0 To intSize - 1

                    astrList(intI) = "Pizza " & Chr(65 + intI)
                Next

                ' Simple call
                objStringList = New clsUDStringList("StringList1", _
                        astrList, 2, , enmStringList.ListBox)


                .AddDataControl(objStringList)

                .objAddString("Tomato and Cheese").strTag = "Item1"
                .objAddString("Ham and Mushroom").strTag = "Item2"
                .objAddString("Tuna and Olives ").strTag = "Item3"

            End With

            AddDataControl(objBlock1)


        Catch objException As Exception

            Throw
        End Try

    End Sub

End Class


