

' A find dialog
Public Class clsFindForm

    Inherits clsDataForm

    Private WithEvents mobjButton1 As clsDataButton
    Private WithEvents mobjDataButtonBlock As clsDataButtonBlock

    ' Constructor
    Public Sub New(Optional ByVal vstrCaption As String = "Find")

        MyBase.New(vstrCaption, enmFormstyle.OptionsDialog, enmButtonTypes.None, enmCompactionSet.Compact, enmPositionSet.RightUpper)

        Dim strButtons As String
        Dim objBlock As clsFindBlock
        Dim objButtonBlockLocal As clsDataBlockList
        
        Try

            objBlock = New clsFindBlock("")

            AddDataControl(objBlock)

            strButtons = "&Find Next, &Replace, &Mark All, Close"
            mobjDataButtonBlock = New clsDataButtonBlock(strButtons)
            mobjDataButtonBlock.objDataButton(3).AddClickHandler(AddressOf close)

            mobjDataButtonBlock.Locate(objBlock, enmPositionSet.RightUpper)
            mobjDataButtonBlock.ctlVisual.intTopPad = 0
            AddDataControl(mobjDataButtonBlock)

            AddConstraints()

        Catch objException As Exception

            Throw New TypeInitializationException(Me.GetType().FullName(), objException)
        End Try

    End Sub


    'ButtonHandler
    Private Sub ButtonHandler(ByVal vobjSender As Object, _
                              ByVal vobjCommandEventArgs As clsCommandClickedEventArgs) Handles mobjDataButtonBlock.evtCommandClicked

        Select Case vobjCommandEventArgs.strTag

            Case "0" : MsgBox("Find function")
            Case "1" : MsgBox("Replace function")
            Case "2" : MsgBox("Mark function")
            Case "3"

        End Select

    End Sub


    ' Add constraints to the Address template
    Private Sub AddConstraints()

        Dim strMessage As String
        Dim objConstraintName As clsConstraintString
        Dim objChecked As clsConstraint
        Dim objDuty As clsDuty

        objChecked = New clsConstraint(True)

        ' Enable use combo only if checkbox is selected
        objUDType("UsE").objAddDuty(objChecked, _
              enmDutyBinding.DataChanged Or enmDutyBinding.Creation, _
              enmControlState.Enabled, objUDType("UseWhat"))

        ' Highlight find box when entered
        objUDType("Findbox").objAddDuty(enmDutyBinding.DataEntered Or enmDutyBinding.Display, enmControlState.Selected)

        strMessage = "Please enter a string to find "

        ' Add a string constraint to the name
        objConstraintName = New clsConstraintString(4, 200, strMessage)

        ' Add a string constraint to the find box
        ' DISABLE

        Exit Sub

        objDuty = objUDType("Findbox").objAddDuty(objConstraintName, enmDutyBinding.Validation, enmControlState.MessageAlert)

        ' objUDType("FindNext").objAddDuty(enmDutyBinding.ButtonPress, enmControlState.DoValidation, _
        '     objUDType("Findbox"))

        objDuty.AddAction(objUDType("Findbox"), enmControlState.Focused, "", enmActOn.Fail)

    End Sub


    Public Shadows Sub close(ByVal vobjSender As Object, _
                             ByVal vobjCommandEventArgs As clsCommandClickedEventArgs)
        MyBase.Close()
    End Sub

End Class


' Standard find block
Public Class clsFindBlock

    Inherits clsDataBlockList


#Region "Variables"

    Private objName, objAddress1, objAddress2, objPostcode As clsUDString
    Private objAddressFlag As clsUDBoolean

#End Region

#Region "Properties (none)"

#End Region

#Region "Methods"

    Friend Sub New(ByVal vstrCaption As String)

        MyBase.New(vstrCaption, enmBorderStyle.None, enmCompactionSet.Regular, enmPositionSet.BottomLeft, "FindBlock")

        Dim astrUseWhat(0) As String
        Dim astrSearchRadios(2) As String
        Dim objCheckUse As clsUDBoolean
        Dim objFindBox As clsUDString
        Dim objUseWhat, objSearchRadios As clsUDStringList
        Dim objBlockSearch As clsDataBlock
        Dim objCheckBlock As clsCoreCheckBlock

        Try

            ' Find box
            objAddString("Find: ")
            objFindBox = New clsUDString("Findbox", "", "Findbox", 40)
            AddDataControl(objFindBox, enmPositionSet.RightLower)

            ' Find options checkboxes
            objCheckBlock = New clsCoreCheckBlock("C&hoice", enmBorderStyle.None, Nothing, enmCompactionSet.Compact)
            objCheckBlock.AddChoice("Match &case")
            objCheckBlock.AddChoice("Match &hidden text")
            objCheckBlock.AddChoice("&Search hidden text")
            objCheckBlock.AddChoice("Search u&p")

            ' Checkbox with the combo to its right hand side
            objCheckUse = objCheckBlock.objAddBoolean("&Use", False, "Use")
            objCheckUse.ctlVisual.intTopPad = 7
            astrUseWhat(0) = "Regular Expressions"
            objUseWhat = New clsUDStringList("UseWhat", astrUseWhat, 0, "UseWhat", enmStringList.Combobox)
            objCheckBlock.AddDataControl(objUseWhat, enmPositionSet.RightMiddle)

            AddDataControl(objCheckBlock)

            ' Add search radios
            astrSearchRadios(0) = "Current &document"
            astrSearchRadios(1) = "All &open document"
            astrSearchRadios(2) = "Only &this procedure"

            objSearchRadios = New clsUDStringList("SearchRadios", astrSearchRadios, 0, "SearchRadios", enmStringList.RadioChoice)
            objBlockSearch = New clsDataBlock("Search", enmBorderStyle.Rectangular, "Search")
            objBlockSearch.AddDataControl(objSearchRadios)
            objBlockSearch.ctlVisualContainer.intLeftMargin = 9
            objBlockSearch.ctlVisualContainer.intBottomMargin = 26
            AddDataControl(objBlockSearch, enmPositionSet.RightUpper)

        Catch objException As Exception

            Throw New TypeInitializationException(Me.GetType().FullName(), objException)
        End Try


    End Sub


#End Region


End Class
