

' Simple form - demonstrates inheritance from clsDataForm
Public Class clsCustomForm

    Inherits clsDataForm

    Private objGeneralBlock, objGeneralBlock2 As clsAddressBlock

    Public Sub New(Optional ByVal vstrCaption As String = "Custom Form")

        MyBase.New(vstrCaption, enmFormstyle.OptionsDialog, enmButtonTypes.OKReturn, enmCompactionSet.Regular, enmPositionSet.BottomRight)

        Try

            Dim objTabbedBlock As clsDataLeaves
            Dim objDataBlock As clsDataBlock

            objGeneralBlock = New clsAddressBlock()

            objDataBlock = New clsDataBlock("", enmBorderStyle.None, "")

            objTabbedBlock = New clsDataLeaves("Tab")
            objTabbedBlock.AddDataControl(objGeneralBlock, "Boo")

            objDataBlock.AddDataControl(objTabbedBlock)
            AddDataControl(objDataBlock)

        Catch objException As Exception

            Throw New TypeInitializationException(Me.GetType().FullName(), objException)
        End Try

    End Sub

End Class



' Standard address list
Public Class clsAddressBlock

    Inherits clsDataBlockListIcon

#Region "Variables"

    Private objName, objAddress1, objAddress2, objPostcode As clsUDString
    Private objAddressFlag As clsUDBoolean

#End Region

#Region "Properties (none)"

#End Region

#Region "Methods"

    Friend Sub New(Optional ByVal vstrCaption As String = "", _
                   Optional ByVal venmBorder As enmBorderStyle = enmBorderStyle.None)

        MyBase.New(vstrCaption, venmBorder, enmCompactionSet.Regular, enmLib.save_zip)

        Dim objName, objAddress1 As clsUDType
        Dim objPicture As clsUDBitmap
        Dim objBlock As clsDataBlockList

        Try


            objName = objAddString("Name1", "", "Name")
            objAddress1 = objAddString("Name2", "", "Address1")
            objAddString("Name3", "", "Address2")
            objAddString("Addr2", "Name", "Address3")

            objPostcode = New clsUDString("PostCode", "HOHOHO", "PostCode", 8, 8, enmString.Label)

            AddDataControl(objPostcode)

            AddConstraints()

        Catch objException As Exception

            Throw New TypeInitializationException(Me.GetType().FullName(), objException)
        End Try

    End Sub

    ' Add constraints to the Address template
    Private Sub AddConstraints()

        Dim strMessage As String
        Dim objConstraintName As clsConstraintString

        strMessage = "Please enter at least 4 characters"

        ' Add a string constraint to the name
        objConstraintName = New clsConstraintString(enmCONSTRAINT_STRING.POSTCODE_UK)
        objUDType("Name").objAddDuty(objConstraintName, enmDutyBinding.Validation)

    End Sub


#End Region


End Class
