

' clsCustomLists is demo of UDStringList types
Public Class clsCustomListForm

    Inherits clsDataForm

    Private WithEvents mobjUDChoice As clsUDStringList
    Private WithEvents mobjButton1 As clsDataButton
    Private WithEvents mobjButton2 As clsDataButton
    Private WithEvents mobjSelection As clsUDInteger


    Public Sub New(Optional ByVal vstrCaption As String = "Custom Lists Form")

        MyBase.New(vstrCaption, enmFormstyle.OptionsDialog, enmButtonTypes.OK, _
                   enmCompactionSet.Regular, enmPositionSet.BottomRight)

        Try

            Dim objGeneralBlock As clsDataBlockList

            objGeneralBlock = objCustomBlock()

            AddDataControl(objGeneralBlock)

            AddDataControl(objButtonBlock(), enmPositionSet.RightUpper)

            mobjSelection = New clsUDInteger("SelectedIndexes")

            AddDataControl(mobjSelection, enmPositionSet.BottomLeft)

        Catch objException As Exception

            Throw New TypeInitializationException(Me.GetType().FullName(), objException)
        End Try

    End Sub


    ' objCustomBlock
    Private Function objCustomBlock() As clsDataBlockList


        Dim astrPickList() As String = {"Red", "Green", "Orange"} ' , "Pink with black spots", "Yellow", "Green", "Purple", "White"}
        Dim objBlock As clsDataBlockList

        objBlock = New clsDataBlockList("Block", enmBorderStyle.Rectangular)

        mobjUDChoice = New clsUDStringList("Chooser", astrPickList, 0, _
                                           "Chooser", enmStringList.CheckChoice)

        ' Add the combo box
        objBlock.AddDataControl(mobjUDChoice)

        Return objBlock

    End Function


    ' Add buttons 
    Private Function objButtonBlock() As clsDataBlockList


        objButtonBlock = New clsDataBlockList("", enmBorderStyle.None, enmCompactionSet.None)

        mobjButton1 = New clsDataButton("&Show selection", False)
        mobjButton1.sglDataWidth = -1
        mobjButton1.sglDataHeight = -1

        objButtonBlock.AddDataControl(mobjButton1, enmPositionSet.DefaultPosition, enmCompactionSet.None)

    End Function


    ' mobjButton1 handler
    Private Sub ShowSelection(ByVal vobjSender As Object, _
                              ByVal vobjCommandClosedEventArgs As clsCommandClickedEventArgs) Handles mobjButton1.evtCommandClicked

        Dim strString, strSelection As String

        If mobjUDChoice.astrValue Is Nothing Then

            strSelection = "Empty"
        Else

            For Each strString In mobjUDChoice.astrValue

                strSelection &= strString & ","
            Next

            strSelection = Left$(strSelection, strSelection.Length - 1)

        End If

        MsgBox("Selection is " & strSelection)

    End Sub


    ' mobjSelection handler
    Private Sub ChangeSelection(ByVal vobjSender As Object, _
                                ByVal vobjEventArgs As clsDataChangedEventArgs) _
                                Handles mobjSelection.evtDataChanged

        Dim intI, intIndex, intBCDValue, intBit As Integer
        Dim aintSelection() As Integer
        Dim astrGamut() As String

        astrGamut = DirectCast(mobjUDChoice.objGamut, String())

        ReDim aintSelection(astrGamut.Length)

        intBCDValue = mobjSelection.intValue

        For intI = 0 To astrGamut.Length - 1

            intBit = CInt(2 ^ intI)
            If (intBCDValue And intBit) = intBit Then

                aintSelection(intIndex) = intI
                intIndex += 1
            End If

        Next

        ReDim Preserve aintSelection(intIndex - 1)

        mobjUDChoice.aintSelection = aintSelection

    End Sub

End Class





