

' A find dialog
Public Class clsPrintForm

    Inherits clsDataForm

    Private WithEvents mobjDataButtonBlock As clsDataButtonBlock

    ' Constructor
    Public Sub New(Optional ByVal vstrCaption As String = "Print")

        MyBase.New(vstrCaption, enmFormStyle.OptionsDialog, enmButtonTypes.None, enmCompactionSet.Compact, enmPositionSet.RightUpper)

        Dim strButtons As String
        Dim objBlock As clsPrinterBlock
        Dim objPrintRangePaneLocal, objCopiesPaneLocal As clsDataBlockList

        Try

            ' Printer choice pane
            objBlock = New clsPrinterBlock("&Printer", enmBorderStyle.Rectangular)
            objBlock.ctlVisual.intBottomPad = 0
            AddDataControl(objBlock)

            ' Range pane
            objPrintRangePaneLocal = objPrintRangePane()
            objPrintRangePaneLocal.ctlVisual.intBottomPad = 8
            objPrintRangePaneLocal.ctlVisual.intTopPad = 0
            AddDataControl(objPrintRangePaneLocal)

            ' Copies pane
            objCopiesPaneLocal = objCopiesPane()
            objCopiesPaneLocal.ctlVisual.intBottomPad = 8
            objCopiesPaneLocal.ctlVisual.intLeftPad = 8
            objCopiesPaneLocal.ctlVisual.intTopPad = 0
            objCopiesPaneLocal.ctlVisualContainer.intBottomMargin = 13
            objCopiesPaneLocal.Locate(objPrintRangePaneLocal, enmPositionSet.RightUpper)
            AddDataControl(objCopiesPaneLocal)

            ' Form buttons
            strButtons = "&Print, Close"
            mobjDataButtonBlock = New clsDataButtonBlock(strButtons)
            mobjDataButtonBlock.Locate(objBlock, enmPositionSet.RightUpper)

            AddDataControl(mobjDataButtonBlock)

        Catch objException As Exception

            Throw New TypeInitializationException(Me.GetType().FullName(), objException)
        End Try

    End Sub


    'ButtonHandler
    Private Sub ButtonHandler(ByVal vobjSender As Object, _
                              ByVal vobjCommandEventArgs As clsCommandClickedEventArgs) Handles mobjDataButtonBlock.evtCommandClicked

        Select Case vobjCommandEventArgs.strTag

            Case "0" : MsgBox("Print function")
            Case "1" : Me.Close()

        End Select

    End Sub


    ' Add buttons adds OK, Cancel buttons for a form
    Private Function objPrintRangePane() As clsDataBlockList

        Dim astrRangeRadios(2) As String
        Dim objRangeRadios As clsUDStringList

        objPrintRangePane = New clsDataBlockList("Print R&ange", enmBorderStyle.Rectangular)

        ' Add Range radios
        astrRangeRadios(0) = "All"
        astrRangeRadios(1) = "Pages 1 to 1"
        astrRangeRadios(2) = "Selection"

        objRangeRadios = New clsUDStringList("RangeRadios", astrRangeRadios, 0, "", enmStringList.RadioChoice)
        objRangeRadios.ctlVisual.intBottomPad = 9
        objPrintRangePane.AddDataControl(objRangeRadios)

    End Function


    ' Add buttons adds OK, Cancel buttons for a form
    Private Function objCopiesPane() As clsDataBlockList

        Dim astrCopies() As String = {"1", "2", "3"}
        Dim bmpBitmap As Bitmap
        Dim objCopies As clsUDStringList
        Dim objCollate As clsUDBoolean
        Dim objIcon As clsUDBitmap

        objCopiesPane = New clsDataBlockList("&Copies", enmBorderStyle.Rectangular)

        objCopiesPane.objAddString("Number of copies")
        objCopies = New clsUDStringList("UseWhat", astrCopies, 0, "UseWhat", enmStringList.Combobox)

        objCopiesPane.AddDataControl(objCopies, enmPositionSet.RightUpper, enmCompactionSet.None)

        '        bmpBitmap = FiveTuple.BusPod.objBusPod.bmpBitmap(FiveTuple.BusPod.enmBusBitmap.enmImage1)
        objIcon = New clsUDBitmap(enmLib.doc_dupl, "")

        objIcon.ctlVisual.intRightPad = 20
        objCopiesPane.AddDataControl(objIcon)

        objCollate = New clsUDBoolean("C&ollate", True, "Collate")
        objCollate.Locate(objIcon, enmPositionSet.RightLower)
        objCopiesPane.AddDataControl(objCollate)

        ' Tidy alignment manually
        objCopiesPane.ctlVisual.intBottomPad += 10

    End Function

End Class


' Standard find block
Public Class clsPrinterBlock

    Inherits clsDataBlockList

#Region "Variables"

    Private objName, objAddress1, objAddress2, objPostcode As clsUDString
    Private objAddressFlag As clsUDBoolean

#End Region

#Region "Properties (none)"

#End Region

#Region "Methods"

    Friend Sub New(Optional ByVal vstrCaption As String = "", _
                   Optional ByVal venmBorder As enmBorderStyle = enmBorderStyle.None)

        MyBase.New(vstrCaption, venmBorder, enmCompactionSet.Regular)

        Dim astrPrinters(0) As String
        Dim astrSearchRadios(2) As String
        Dim objCheckUse As clsUDBoolean
        Dim objFindBox As clsUDString
        Dim objPrinter As clsUDStringList
        Dim objBlockSearch As clsDataBlock
        Dim objCheckBlock As clsCoreCheckBlock
        Dim objButton1 As clsDataButton

        Try

            ' Printer dropdown
            objAddString("Printer: ")
            astrPrinters(0) = "\\NEON\HP LaserJet 3300"
            objPrinter = New clsUDStringList("UseWhat", astrPrinters, 0, "UseWhat", enmStringList.Combobox)
            AddDataControl(objPrinter, enmPositionSet.RightUpper)

            ' Properties button
            objButton1 = New clsDataButton("Properties", False, "False", AddressOf PrinterProperties)
            objButton1.ctlVisual.intLeftPad = 10
            AddDataControl(objButton1, enmPositionSet.RightUpper)

            objAddString("Status")
            objAddString("Type")
            objAddString("Where")
            'objAddString("Comment")

            ' AddConstraints()

        Catch objException As Exception

            Throw New TypeInitializationException(Me.GetType().FullName(), objException)
        End Try

    End Sub


    ' Add constraints to the Address template
    Private Sub AddConstraints()

        Dim objConstraintName As clsConstraintString

        ' Add a string constraint to the name
        objConstraintName = New clsConstraintString(4)
        objUDType("Name").objAddDuty(objConstraintName, enmDutyBinding.Validation)

        ' Add a string constraint to the address
        objUDType("Address").objAddDuty(objConstraintName, enmDutyBinding.Validation)

    End Sub

    ' Stub for Properties button
    Private Sub PrinterProperties(ByVal vobjSender As Object, _
                                  ByVal vargs As clsCommandClickedEventArgs)

        MsgBox("Demo only")
    End Sub

#End Region


End Class
