
' A find dialog
Public Class clsViewForm

    Inherits clsDataForm

    Private mblnSwap As Boolean
    Private mtblSample As DataTable
    Private mtblSample1 As DataTable
    Private mtblSample2 As DataTable

    Private WithEvents mobjViewSet As clsUDViewSet
    Private WithEvents mobjButton1 As clsDataButton
    Private WithEvents mobjFieldBlock As clsCoreStringBlock

    ' Constructor
    Public Sub New(Optional ByVal vstrCaption As String = "Find")

        MyBase.New(vstrCaption, enmFormstyle.OptionsDialog, enmButtonTypes.None, enmCompactionSet.Compact)

        Dim strFormat As String
        Dim objPostBlockLocal As clsDataBlockList
        Dim objUpdateBlockLocal As clsDataBlockList
        Dim objPostSelected As clsDataButton
        Dim objButtonBlockLocal As clsDataBlockList

        Try

            mtblSample1 = tblGetSample(1)
            mtblSample2 = tblGetSample(2)
            mblnSwap = False
            mtblSample = mtblSample1

            mobjViewSet = New clsUDViewSet("Sample", mtblSample, "SampleList", strFormat, enmViewSet.ListView)
            mobjViewSet.sglDataWidth = 20

            AddDataControl(mobjViewSet)

            objButtonBlockLocal = objButtonBlock()

            mobjFieldBlock = objFieldBlock()

            AddDataControl(mobjFieldBlock, enmPositionSet.RightUpper)

            AddDataControl(objButtonBlockLocal, enmPositionSet.BottomLeft)

        Catch objException As Exception

            Throw New TypeInitializationException(Me.GetType().FullName(), objException)
        End Try

    End Sub


    ' Add buttons adds OK, Cancel buttons for a form
    Private Function objButtonBlock() As clsDataBlockList


        objButtonBlock = New clsDataBlockList("ButtonBlock", enmBorderStyle.None, enmCompactionSet.None)

        mobjButton1 = New clsDataButton("Swap Dataset", False, "SwapDataset", -1)
        objButtonBlock.AddDataControl(mobjButton1)
        Me.AcceptButton = mobjButton1


    End Function


    ' Adds fields
    Private Function objFieldBlock() As clsCoreStringBlock

        Dim strCol, strFields As String
        Dim dclColumn As DataColumn
        Dim objBlock As clsCoreStringBlock

        For Each dclColumn In mtblSample1.Columns

            strFields &= dclColumn.ColumnName & ","
        Next

        strFields = Left$(strFields, strFields.Length - 1)

        objBlock = New clsCoreStringBlock("Detail", strFields, 20)

        Return objBlock

    End Function


    ' mobjButton1 handler
    Private Sub SwapDataset(ByVal vobjSender As Object, _
                            ByVal vobjCommandClosedEventArgs As clsCommandClickedEventArgs) Handles mobjButton1.evtCommandClicked

        If Not mobjViewSet.aintSelection Is Nothing Then

            If mblnSwap Then

                mtblSample = mtblSample2
            Else
                mtblSample = mtblSample1
            End If

            mobjViewSet.objGamut = mtblSample
            mblnSwap = Not mblnSwap

            UpdateFields(Nothing, Nothing)

        End If

    End Sub


    ' mobjViewSet Selection Changed handler
    Private Sub UpdateFields(ByVal vobjSender As Object, _
                             ByVal vobjEventArgs As clsDataChangedEventArgs) Handles mobjViewSet.evtDataChanged


        Dim strCol, strField As String
        Dim dclColumn As DataColumn

        For Each dclColumn In mtblSample.Columns

            strCol = dclColumn.ColumnName
            strField = CStr(mtblSample.Rows(mobjViewSet.intSelection).Item(strCol))
            mobjFieldBlock(strCol) = strField

        Next

    End Sub


End Class
