

' clsSimpleFormMenu demonstrates menu functions
Public Class clsSimpleFormMenu

    Inherits clsSimpleForm

#Region "Variables"

    Private objSimpleBlock As clsCoreStringBlock

#End Region

#Region "Properties (none)"

#End Region

#Region "Methods"

    ' vstrFieldList is a CSV list of field captions
    Public Sub New(ByVal vstrFieldList As String, _
                   Optional ByVal vstrFormCaption As String = "", _
                   Optional ByVal vstrBlockCaption As String = "", _
                   Optional ByVal vintWidth As Integer = 30)

        MyBase.New(vstrFieldList, vstrFormCaption, vstrBlockCaption, vintWidth)

        Dim strFilename, strFile As String
        Dim icoIcon As Icon
        Dim objDataMenu As clsDataMenu
        Dim objDataSubMenu1, objDataSubMenu2, objDataSubMenu3 As clsDataMenu
        Dim objDataSubSubMenu1, objDataSubSubMenu2 As clsDataMenu

        Try

            ' Example code for adding main and context menus
            objDataSubMenu1 = New clsDataMenu("Context Only")
            objDataSubMenu1.enmMenuSiting = enmMenuSitingSet.enmMenuContext

            objDataSubSubMenu1 = New clsDataMenu("Context submenu")
            objDataSubSubMenu1.enmMenuSiting = enmMenuSitingSet.enmMenuContext
            objDataSubMenu1.AddDataMenu(objDataSubSubMenu1)

            objDataSubMenu2 = New clsDataMenu("Main Only")
            objDataSubMenu2.enmIcon = enmMenuIcon.Find
            objDataSubMenu2.enmMenuSiting = enmMenuSitingSet.enmMenuMain

            objDataSubSubMenu2 = New clsDataMenu("Main submenu 1")
            objDataSubSubMenu2.enmMenuSiting = enmMenuSitingSet.enmMenuMain
            objDataSubMenu2.AddDataMenu(objDataSubSubMenu2)
            objDataSubMenu2.objAddDataMenu("Main submenu 2", "MainSubmenu2", enmMenuSitingSet.enmMenuMain)

            objDataSubMenu3 = New clsDataMenu("Main and Context")
            objDataSubMenu3.enmMenuSiting = enmMenuSitingSet.enmMenuMainAndContext


            ' Note that the header menu must be file and context, or context submenus will not be shown
            objDataMenu = objAddMenu("File", "Quit (Main and Context)", enmMenuSitingSet.enmMenuMainAndContext)
            objDataMenu.AddDataMenu(objDataSubMenu1)
            objDataMenu.AddDataMenu(objDataSubMenu2)
            objDataMenu.AddDataMenu(objDataSubMenu3)

        Catch objException As Exception

            Throw New TypeInitializationException(Me.GetType().FullName(), objException)
        End Try

    End Sub

    ' Event handler - menus
    Friend Sub MenuClickEventHandler(ByVal vobjSender As Object, _
                                     ByVal vobjEventArgs As clsMenuClickedEventArgs) Handles MyBase.evtMenuClicked

        Try

            MsgBox(vobjEventArgs.strTag & " Clicked")

            objGetDataMenu("MainSubmenu2").SetState(enmControlState.NotEnabled)

        Catch objException As Exception

            Throw

        End Try

    End Sub


#End Region

End Class




