

' clsMainForm demonstrates DataForm
Public Class clsMainForm

    Inherits clsDataForm


    Friend Sub New()

        MyBase.New("DataForm Demo", enmFormStyle.FixedForm, enmButtonTypes.OKReturnCancelEscape)

        Dim objString As clsUDString
        Dim objFormsMenu As clsDataMenu
        Dim objSubMenu1, objSubMenu2 As clsDataMenu

        Try

            ' Header menu File
            objAddMenu("&File", "E&xit")

            ' Header menu Controls
            objAddMenu("Controls", "Boolean,Numerics,Dates,-,String,String Lists,-,Image,ViewSets,Buttons")

            ' Header menu Constraints
            objAddMenu("Constraints", "String - simple, Numeric, Date, Stringlist, Overlay")

            ' Header menu Forms
            objFormsMenu = objAddDataMenu("Forms")

            ' Header menu Help
            objAddMenu("Help", "Test,About..")

            ' Submenu Basic Forms 
            objSubMenu1 = objFormsMenu.objAddMenu("Basic Forms", "Simple Form,Tabbed Form,Menus")

            objSubMenu1.objGetDataMenu(0).enmIcon = enmMenuIcon.doc
            objSubMenu1.objGetDataMenu(1).enmIcon = enmMenuIcon.doc_tabbed_new
            objSubMenu1.objGetDataMenu(2).enmIcon = enmMenuIcon.select1
            objSubMenu1.enmIcon = enmMenuIcon.Print

            ' Submenu Custom Forms 
            objSubMenu2 = objFormsMenu.objAddMenu("Custom Forms", _
                                                 "Find, Print")
            objSubMenu2.objGetDataMenu(0).enmIcon = enmMenuIcon.find
            objSubMenu2.objGetDataMenu(1).enmIcon = enmMenuIcon.print

            ' Submenu Various
            objFormsMenu.objAddMenu("Various", "Button Blocks")

            ' Submenu Tables and Lists
            objFormsMenu.objAddMenu("Tables and Lists", "View Form, Lists")

            ' Submenu Plugins
            objFormsMenu.objAddMenu("Plugins", "Separator")

            objString = objAddString(" ")
            objString.ctlVisual.intTopPad = 60
            objString.ctlVisual.intBottomPad = 200
            objString.ctlVisual.intRightPad = 300


        Catch objException As Exception

            Throw
        End Try

    End Sub


    ' Event handler - menus
    Friend Sub MenuClickEventHandler(ByVal vobjSender As Object, _
                                     ByVal vobjEventArgs As clsMenuClickedEventArgs) Handles MyBase.evtMenuClicked

        Dim strTag As String

        Try

            strTag = vobjEventArgs.strTag

            ' File menu options
            If strTag = "Exit" Then Me.Close()

            ' Control menu options
            If strTag = "Boolean" Then RunControlForm(New clsBooleanForm)
            If strTag = "Numerics" Then RunControlForm(New clsNumericForm)
            If strTag = "Dates" Then RunControlForm(New clsDateForm)
            If strTag = "String" Then RunControlForm(New clsStringForm)
            If strTag = "Image" Then RunControlForm(New clsImageForm)
            If strTag = "String Lists" Then RunControlForm(New clsStringListForm)
            If strTag = "ViewSets" Then RunControlForm(New clsViewSetForm)
            If strTag = "Buttons" Then RunControlForm(New clsButtonForm)

            ' Constraint menu options
            If strTag = "String - simple" Then RunControlForm(New clsConstraintsString)
            If strTag = "Numeric" Then RunControlForm(New clsConstraintsNumeric)
            If strTag = "Date" Then RunControlForm(New clsConstraintsDate)
            If strTag = "Stringlist" Then RunControlForm(New clsConstraintsStringList)
            If strTag = "Overlay" Then RunControlForm(New clsConstraintsOverlay)

            ' Form menu options
            If strTag = "Simple Form" Then RunSimpleForm()
            If strTag = "Tabbed Form" Then RunCustomTabbedForm()
            If strTag = "Menus" Then RunSimpleFormMenu()
            If strTag = "Find" Then RunCustomFindForm()
            If strTag = "Print" Then RunCustomPrintForm()
            If strTag = "Button Blocks" Then RunSimpleButtonBlock()
            If strTag = "View Form" Then RunCustomViewForm()
            If strTag = "Lists" Then RunCustomLists()
            If strTag = "Separator" Then RunSimpleCustomControls()

            ' Help menu options
            If strTag = "Test" Then RunTest()
            If strTag = "About.." Then ShowAbout()


        Catch objException As Exception

            gobjErrorHandler.ErrorHandler(objException)

        End Try

    End Sub


    ' RunViewsetControls
    Friend Sub RunControlForm(ByVal vobjForm As clsDataForm)


        Try

            vobjForm.Expose(True)

            vobjForm.Dispose()

        Catch objException As Exception

            gobjErrorHandler.ErrorHandler(objException)

        End Try

    End Sub


    ' ShowAbout
    Private Sub ShowAbout()


        Dim objAboutForm As clsAboutForm

        Try

            objAboutForm = New clsDataFormTestAbout()

            objAboutForm.Expose(True)

            objAboutForm.Dispose()

        Catch objException As Exception

            gobjErrorHandler.ErrorHandler(objException)

        End Try

    End Sub


    ' RunTest
    Private Sub RunTest()

        Dim intI As Integer
        Dim dtmT1, dtmT2 As DateTime
        Dim objPrintForm As clsPrintForm

        Try

            dtmT1 = Now()

            For intI = 1 To 100

                objPrintForm = New clsPrintForm

                objPrintForm.Expose(False)

                objPrintForm.Close()

                objPrintForm.Dispose()

            Next

            dtmT2 = Now()

            MsgBox("The test took " & dtmT2.Subtract(dtmT1).ToString & " seconds")

        Catch objException As Exception

            gobjErrorHandler.ErrorHandler(objException)

        End Try

    End Sub

End Class




